commit 4f9ad140c6c2ca51b591f44f7579cc3b81356291
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Sat Dec 18 23:21:35 2021

    Fortran: reject BOZ type argument to SIZEOF().
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103412
            * check.c (gfc_check_sizeof): Reject BOZ type argument.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103412
            * gfortran.dg/illegal_boz_arg_2.f90: New test.
    
    (cherry picked from commit fd74a2ee40456a1d1621e88738f8e57536194080)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index 7b4b5916d07..8cd894d48d8 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -5151,6 +5151,9 @@ gfc_check_sizeof (gfc_expr *arg)
       return false;
     }
 
+  if (illegal_boz_arg (arg))
+    return false;
+
   /* TYPE(*) is acceptable if and only if it uses an array descriptor.  */
   if (arg->ts.type == BT_ASSUMED
       && (arg->symtree->n.sym->as == NULL
diff --git a/gcc/testsuite/gfortran.dg/illegal_boz_arg_2.f90 b/gcc/testsuite/gfortran.dg/illegal_boz_arg_2.f90
new file mode 100644
index 00000000000..3e5f6b6d1d4
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/illegal_boz_arg_2.f90
@@ -0,0 +1,6 @@
+! { dg-do compile }
+! PR fortran/103412
+
+program p
+  integer, parameter :: a = sizeof(z'1') ! { dg-error "cannot be an actual" }
+end

